**********************************************************************
**   DEMO * DEMO * DEMO * DEMO * DEMO * DEMO * DEMO * DEMO * DEMO   **
**********************************************************************
**   REPORT ZAF_PDF_SET                                             **
**********************************************************************
**                                                                  **
**                        RBARC/PDF417                              **
**                       for Adobeforms                             **
**                             V12                                  **
**                Copyright (C) 2007-2016 Suchy MIPS                **
**                      All rights reserved                         **
**                                                                  **
**                       DEMO Version                               **
**                                                                  **
**********************************************************************
**  Serial No.: DEMO                                                **
**********************************************************************
**                     NOT FOR PRODUCTIVE USE!!!                    **
**********************************************************************
**                                                                  **
**  This is a part of RBarc/PDF417(c)                               **
**                                                                  **
**  Collects data passed form a Adobeforms form, sets parameters    **
**  for the PDF-417 label and generates the PDF-417 bar code        **
**  using RBarc/PDF417 from Suchy MIPS                              **
**                                                                  **
**  The entry point is the form GEN_PDF417                          **
**                                                                  **
**  The customer is allowed to change this file and adapt it        **
**  to its own needs.                                               **
**  Read comments in the code to get familiar with what is to do.   **
**  For detailed instructions refere to the manual                  **
**                                                                  **
**  Suchy MIPS shall not be liable for errors contained herein or   **
**  for incidental consequential damages in connection with use of  **
**  thisprogram.                                                    **
**                                                                  **
**  THIS PROGRAM SHELL BE INSTALLED IN THE TEST ENVIRONMENT         **
**  AND TESTED BEFORE USING ON THE PRODUCTIVE SYSTEM                **
**                                                                  **
**  Suchy MIPS GmbH                                                 **
**  Prinzregentenstraße 128                                         **
**  81677 Muenchen                                                  **
**  Germany                                                         **
**  Phone:   +49-89-944 19 77 - 0                                   **
**  Fax:     +49-89-944 19 77 - 13                                  **
**  E-mail   info@suchymips.de                                      **
**  Internet: www.suchymips.de                                      **
**********************************************************************
**********************************************************************
**  Released: 16.05.2013                                            **
**  Version:  12                                                    **
**  Release:  12.0.1                                                **
**********************************************************************
**********************************************************************

REPORT zaf_pdf_set.


DATA: pdf(256), eclevel TYPE i, rows TYPE i, columns TYPE i,
      aspratio TYPE f, x_dim TYPE f, y_dim TYPE f, truncate TYPE i,
      xpos TYPE f, ypos TYPE f, rot TYPE i, postyp TYPE i,
      text_id(4), bcvalue01(40), barident(10), unit(4),
      smvar1(31), smvar2(31), smvar3(31), smvar_n(70),
      smchg1 TYPE string, smchg2(31), smchg3(31), no_err_print TYPE i,
      pdfvalue01(80), pdfident(10), graphic TYPE i value 3,
      bitmap_name TYPE tdobname,
      bc_content TYPE xstring.

perform gen_pdf417 using 'ABC' 'DEF' 'GHI' 'JKL' 'PDF01'
      changing bc_content.
*----FORM GEN_PDF417 interface to AdobeForms ---------------------------
FORM gen_pdf417 USING    pdfvalue01 pdfvalue02 pdfvalue03 pdfvalue04
                         pdfident
                CHANGING $bc_content.

*----Inititalizing buffer for variables---------------------------------
  PERFORM init_pdfdata.

*----reading variables from Adobeform and writing them to the buffer----

  PERFORM collect_pdf USING pdfvalue01 'LF' 'CR' '' '' ''.
  PERFORM collect_pdf USING pdfvalue02 'LF' 'CR' '' '' ''.
  PERFORM collect_pdf USING pdfvalue03 'LF' 'CR' '' '' ''.
  PERFORM collect_pdf USING pdfvalue04 'LF' 'CR' '' '' ''.




*----starting form which sets parameters for PDF417 and performs-------
*----bar code generating
  CASE pdfident.
    WHEN 'PDF01'.
      PERFORM pdf01.
  ENDCASE.


*---import bmp as binary object
  bitmap_name = smchg1.

  CALL METHOD cl_ssf_xsf_utilities=>get_bds_graphic_as_bmp
    EXPORTING
      p_object       = 'GRAPHICS'
      p_name         = bitmap_name
      p_id           = 'BMAP'
      p_btype        = 'BMON'
    RECEIVING
      p_bmp          = $bc_content
    EXCEPTIONS
      not_found      = 1
      internal_error = 2
      OTHERS         = 3.

*---delete barcode
  PERFORM del_pdf_bmp USING bitmap_name.

ENDFORM.                                                    "GEN_PDF417
*----END OF FORM GEN_PDF417 --------------------------------------------

*----FORM PDF01: sets parameters for PDF417 and performs bar code gen.--
FORM pdf01.

***Measure Units MM, CM or Inch valid for: XPOS, YPOS, X_DIM, Y_DIM
  unit = 'MM'.

*** Error correction Level. Valid 0 - 8.
*** ECLEVEL > 8 causes automatic calculation of ECC Level.
*** AT Demo Version ECLEVEL will be automatically switched to 1.
  eclevel = 10.

*** Number of Rows and Columns the PDF should be generated.
*** Set Rows and Columns to 0 and use ASPRATIO (label hight/label width)
*** for automatic calculation of no. of Rows and Columns for this label
  rows = 0. columns = 0. aspratio = '0.5'.

*** X_DIM, Y_DIM: the size of the modul (smallest element of PDF).
*** usually the relation Y_DIM/X_DIM should be about 3.
  x_dim = '0.350'. y_dim = '1.250'.


*** Generates truncated PDF (without Right Row Indicator and Stop
*** patterns. Truncate = 0: DON'T PRINT Truncated PDF
***           Truncate = 1: DO PRINT Truncated PDF
  truncate = 0.

*** Text_ID: identification for this PDF Label. You can define more
*** than 1 PDF Label in this program. Use different Identifier
*** for each defined label (up to 4 chars are allowed).
  text_id = 'P1'.

*** If you make mistakes in defining PDF parameters, RBarc/PDF417(c)
*** prints all errors, but it sets all wrong values to
*** default. You can print this label without error messages
*** by setting the value of NO_ERR_PRINT to 1.
*** Note: it only makes sens to set this value to 1
***       If you have errors but want to see the PDF anyway.
  no_err_print = 0.


*** Barcode Rotation.
*** Valid values are: 0, 90, 180 and 270.
  rot = 0.

  PERFORM gen_pdf.


ENDFORM.                                                    "PDF01
*----END OF FORM PDF01 -------------------------------------------------


*---------------------------------------------------------------------*
*       DELETE BARCODE BITMAP                                         *
* This form delets the text created by RBarc+                         *
* it should be performed  immediatelly after including the bar code   *
* into the form                                                       *
*---------------------------------------------------------------------*

FORM del_pdf_bmp USING smvar_n .

  DATA:
  i_name LIKE stxbitmaps-tdname,
  i_object LIKE stxbitmaps-tdobject,
  i_id LIKE stxbitmaps-tdid,
  i_btype LIKE  stxbitmaps-tdbtype,
  error LIKE sy-subrc.

  i_name = smvar_n.

  CALL FUNCTION 'SAPSCRIPT_DELETE_GRAPHIC_BDS'
    EXPORTING
      i_object      = 'GRAPHICS'
      i_name        = i_name
      i_id          = 'BMAP'
      i_btype       = 'BMON'
      dialog        = ''
    EXCEPTIONS
      delete_failed = 1
      not_found     = 2
      canceled      = 3
      OTHERS        = 4.

  error = sy-subrc.
ENDFORM.                    "DEL_PDF_BMP

*----FORM GEN_PDF: calls RBarc/PDF417(c) and generates the PDF bar code-
FORM gen_pdf.
* smvar2 = 75.
  PERFORM print_pdf
           USING    eclevel rows columns aspratio x_dim y_dim unit
                    truncate xpos ypos postyp text_id no_err_print
                    graphic rot
                    smvar1 smvar2 smvar3
           CHANGING smchg1 smchg2 smchg3.

ENDFORM.                    "GEN_PDF
*----END OF FORM GEN_PDF------------------------------------------------
INCLUDE zaf_rbarcpdf.